## gitaly 1.78.0+dfsg

=== Makefile ===
# Top-level Makefile for Gitaly
#
# Responsibilities of this file:
# - create GOPATH in _build with symlink to current dir
# - re-generate _build/Makefile from makegen.go on each run
# - dispatch commands to _build/Makefile
#
# "Magic" should happen in the makegen.go dynamic template. We want
# _build/Makefile to be as static as possible.

BUILD_DIR = _build
PKG = gitlab.com/gitlab-org/gitaly
MAKEGEN = $(BUILD_DIR)/makegen

# These variables are handed down to make in _build
export PATH := $(BUILD_DIR)/bin:$(PATH)
export TEST_REPO_STORAGE_PATH := $(CURDIR)/internal/testhelper/testdata/data
export SOURCE_DIR := $(CURDIR)
export GO111MODULE = on

all: build

.PHONY: build
build: prepare-build
	cd $(BUILD_DIR) && $(MAKE) install INSTALL_DEST_DIR=$(CURDIR)

.PHONY: build-gitaly-remote
build-gitaly-remote: prepare-build
	cd $(BUILD_DIR) && $(MAKE) $@

.PHONY: test-gitaly-remote
test-gitaly-remote: prepare-build
	cd $(BUILD_DIR) && $(MAKE) $@

.PHONY: install
install: prepare-build
	cd $(BUILD_DIR) && $(MAKE) $@

.PHONY: assemble
assemble: prepare-build
	cd $(BUILD_DIR) && $(MAKE) $@

.PHONY: binaries
binaries: prepare-build
	cd $(BUILD_DIR) && $(MAKE) $@

.PHONY: prepare-tests
prepare-tests: prepare-build
	cd $(BUILD_DIR) && $(MAKE) $@

.PHONY: test
test: prepare-build
	cd $(BUILD_DIR) && $(MAKE) $@

.PHONY: test-with-proxies
test-with-proxies: prepare-build
	cd $(BUILD_DIR) && $(MAKE) $@

.PHONY: rspec
rspec: prepare-build
	cd $(BUILD_DIR) && $(MAKE) $@

.PHONY: rspec-gitlab-shell
rspec-gitlab-shell: prepare-build
	cd $(BUILD_DIR) && $(MAKE) $@

.PHONY: verify
verify: prepare-build
	cd $(BUILD_DIR) && $(MAKE) $@

.PHONY: verify-warnings
verify-warnings: prepare-build
	cd $(BUILD_DIR) && $(MAKE) $@

.PHONY: format
format: prepare-build
	cd $(BUILD_DIR) && $(MAKE) $@

.PHONY: cover
cover: prepare-build
	cd $(BUILD_DIR) && $(MAKE) $@

.PHONY: notice
notice: prepare-build
	cd $(BUILD_DIR) && $(MAKE) $@

.PHONY: race-go
race-go: prepare-build
	cd $(BUILD_DIR) && $(MAKE) $@

.PHONY: docker
docker: prepare-build
	cd $(BUILD_DIR) && $(MAKE) $@

.PHONY: proto
proto: prepare-build
	cd $(BUILD_DIR) && $(MAKE) $@

.PHONY: no-changes
no-changes: prepare-build
	cd $(BUILD_DIR) && $(MAKE) $@

.PHONY: smoke-test
smoke-test: prepare-build
	cd $(BUILD_DIR) && $(MAKE) $@

.PHONY: prepare-build
prepare-build: $(BUILD_DIR)/.ok update-makefile
$(BUILD_DIR)/.ok:
	mkdir -p $(BUILD_DIR)/src/$(shell dirname $(PKG))
	cd $(BUILD_DIR)/src/$(shell dirname $(PKG)) && rm -f $(shell basename $(PKG)) && \
		ln -sf ../../../.. $(shell basename $(PKG))
	touch $@

.PHONY: update-makefile
update-makefile: _build/makegen $(BUILD_DIR)/.ok
	cd $(BUILD_DIR) && ./makegen > Makefile

# This go.mod file soaks up go.mod/go.sum changes that we don't want in the top-level go.mod.
$(BUILD_DIR)/go.mod: $(BUILD_DIR)/.ok
	(cd $(BUILD_DIR) && go mod init _build)

_build/makegen: _support/makegen.go $(BUILD_DIR)/go.mod
	cd $(BUILD_DIR) && go build -o $(CURDIR)/$@ $(SOURCE_DIR)/_support/makegen.go

clean:
	git clean -fdX

=== internal/middleware/cache/Makefile ===
testdata/%.pb.go: testdata/%.proto
	go mod download gitlab.com/gitlab-org/gitaly-proto
	protoc --go_out=paths=source_relative,plugins=grpc:./testdata -I${shell go list -m -f '{{ .Dir }}' gitlab.com/gitlab-org/gitaly-proto} -I$(shell pwd)/testdata $(shell pwd)/testdata/*.proto

=== internal/praefect/grpc-proxy/testdata/Makefile ===

all: test_go

test_go: test.proto
	PATH="${GOPATH}/bin:${PATH}" protoc \
	  -I. \
		-I${GOPATH}/src \
		--go_out=plugins=grpc:. \
		test.proto

=== vendor/gitlab.com/gitlab-org/labkit/vendor/github.com/uber/jaeger-client-go/Makefile ===
PROJECT_ROOT=github.com/uber/jaeger-client-go
PACKAGES := $(shell glide novendor | grep -v -e ./thrift-gen/... -e ./thrift/...)
# all .go files that don't exist in hidden directories
ALL_SRC := $(shell find . -name "*.go" | grep -v -e vendor -e thrift-gen -e ./thrift/ \
        -e ".*/\..*" \
        -e ".*/_.*" \
        -e ".*/mocks.*")

-include crossdock/rules.mk

export GO15VENDOREXPERIMENT=1

RACE=-race
GOTEST=go test -v $(RACE)
GOLINT=golint
GOVET=go vet
GOFMT=gofmt
FMT_LOG=fmt.log
LINT_LOG=lint.log

THRIFT_VER=0.9.3
THRIFT_IMG=thrift:$(THRIFT_VER)
THRIFT=docker run -v "${PWD}:/data" $(THRIFT_IMG) thrift
THRIFT_GO_ARGS=thrift_import="github.com/apache/thrift/lib/go/thrift"
THRIFT_GEN_DIR=thrift-gen

PASS=$(shell printf "\033[32mPASS\033[0m")
FAIL=$(shell printf "\033[31mFAIL\033[0m")
COLORIZE=sed ''/PASS/s//$(PASS)/'' | sed ''/FAIL/s//$(FAIL)/''

.DEFAULT_GOAL := test-and-lint

.PHONY: test-and-lint
test-and-lint: test fmt lint

.PHONY: test
test:
	bash -c "set -e; set -o pipefail; $(GOTEST) $(PACKAGES) | $(COLORIZE)"

.PHONY: fmt
fmt:
	$(GOFMT) -e -s -l -w $(ALL_SRC)
	./scripts/updateLicenses.sh

.PHONY: lint
lint:
	$(GOVET) $(PACKAGES)
	@cat /dev/null > $(LINT_LOG)
	@$(foreach pkg, $(PACKAGES), $(GOLINT) $(pkg) | grep -v crossdock/thrift >> $(LINT_LOG) || true;)
	@[ ! -s "$(LINT_LOG)" ] || (echo "Lint Failures" | cat - $(LINT_LOG) && false)
	@$(GOFMT) -e -s -l $(ALL_SRC) > $(FMT_LOG)
	./scripts/updateLicenses.sh >> $(FMT_LOG)
	@[ ! -s "$(FMT_LOG)" ] || (echo "go fmt or license check failures, run 'make fmt'" | cat - $(FMT_LOG) && false)


.PHONY: install
install:
	glide --version || go get github.com/Masterminds/glide
ifeq ($(USE_DEP),true)
	dep ensure
else
	glide install
endif


.PHONY: cover
cover:
	./scripts/cover.sh $(shell go list $(PACKAGES))
	go tool cover -html=cover.out -o cover.html


# This is not part of the regular test target because we don't want to slow it
# down.
.PHONY: test-examples
test-examples:
	make -C examples

# TODO at the moment we're not generating tchan_*.go files
thrift: idl-submodule thrift-image
	$(THRIFT) -o /data --gen go:$(THRIFT_GO_ARGS) --out /data/$(THRIFT_GEN_DIR) /data/idl/thrift/agent.thrift
	$(THRIFT) -o /data --gen go:$(THRIFT_GO_ARGS) --out /data/$(THRIFT_GEN_DIR) /data/idl/thrift/sampling.thrift
	$(THRIFT) -o /data --gen go:$(THRIFT_GO_ARGS) --out /data/$(THRIFT_GEN_DIR) /data/idl/thrift/jaeger.thrift
	$(THRIFT) -o /data --gen go:$(THRIFT_GO_ARGS) --out /data/$(THRIFT_GEN_DIR) /data/idl/thrift/zipkincore.thrift
	$(THRIFT) -o /data --gen go:$(THRIFT_GO_ARGS) --out /data/$(THRIFT_GEN_DIR) /data/idl/thrift/baggage.thrift
	$(THRIFT) -o /data --gen go:$(THRIFT_GO_ARGS) --out /data/crossdock/thrift/ /data/idl/thrift/crossdock/tracetest.thrift
	sed -i '' 's|"zipkincore"|"$(PROJECT_ROOT)/thrift-gen/zipkincore"|g' $(THRIFT_GEN_DIR)/agent/*.go
	sed -i '' 's|"jaeger"|"$(PROJECT_ROOT)/thrift-gen/jaeger"|g' $(THRIFT_GEN_DIR)/agent/*.go
	sed -i '' 's|"github.com/apache/thrift/lib/go/thrift"|"github.com/uber/jaeger-client-go/thrift"|g' \
		$(THRIFT_GEN_DIR)/*/*.go crossdock/thrift/tracetest/*.go
	rm -rf thrift-gen/*/*-remote
	rm -rf crossdock/thrift/*/*-remote
	rm -rf thrift-gen/jaeger/collector.go

idl-submodule:
	git submodule init
	git submodule update

thrift-image:
	$(THRIFT) -version

.PHONY: install-dep-ci
install-dep-ci:
	- curl -L -s https://github.com/golang/dep/releases/download/v0.3.2/dep-linux-amd64 -o $$GOPATH/bin/dep
	- chmod +x $$GOPATH/bin/dep

.PHONY: install-ci
install-ci: install-dep-ci install
	go get github.com/wadey/gocovmerge
	go get github.com/mattn/goveralls
	go get golang.org/x/tools/cmd/cover
	go get github.com/golang/lint/golint

.PHONY: test-ci
test-ci:
	@./scripts/cover.sh $(shell go list $(PACKAGES))
	make lint

=== debian/changelog ===
gitaly (1.78.0+dfsg-2) unstable; urgency=medium

  * Reupload to unstable
  * Build with golang 1.13
  * Allow grpc and google-protobuf from unstable in ruby/Gemfile
  * Allow ruby-grpc and ruby-google-protobuf from unstable

 -- Pirate Praveen <praveen@debian.org>  Mon, 13 Jan 2020 23:35:57 +0530

gitaly (1.78.0+dfsg-1) experimental; urgency=medium

  * New upstream version 1.78.0+dfsg
  * Add golang-github-lib-pq-dev as build dependency
  * Use golang version of grpc from system

 -- Pirate Praveen <praveen@debian.org>  Wed, 01 Jan 2020 00:41:02 +0530

gitaly (1.72.1+dfsg-2) experimental; urgency=medium

  * Relax dependency on grpc and google-protobuf in ruby/Gemfile
    (This fixes 503 errors when using older versions of grpc and protobuf)

 -- Pirate Praveen <praveen@debian.org>  Mon, 30 Dec 2019 17:33:27 +0530

gitaly (1.72.1+dfsg-1) experimental; urgency=medium

  * New upstream version 1.72.1+dfsg
  * Add golang-goprotobuf-dev as build dependency
  * Refresh patches
  * Bump minimum version of ruby-github-linguist to 7.5

 -- Pirate Praveen <praveen@debian.org>  Wed, 25 Dec 2019 22:39:55 +0530

gitaly (1.67.1+dfsg-1) experimental; urgency=medium

  * Update README.source
  * New upstream version 1.67.1+dfsg

 -- Pirate Praveen <praveen@debian.org>  Mon, 23 Dec 2019 17:50:56 +0530

gitaly (1.65.2+dfsg-1) experimental; urgency=medium

  * New upstream version 1.65.2+dfsg (Fixes: CVE-2019-19260)
  * Update minimum version of ruby-gitlab-labkit labkit to 0.5~

 -- Pirate Praveen <praveen@debian.org>  Fri, 29 Nov 2019 12:24:29 +0530

gitaly (1.59.3+dfsg-2) experimental; urgency=medium

  * Tighten build dependncy on grpc and protobuf
  * Tighten dependency on ruby-activesupport
  * Allow protobuf 3.7.1 and grpc 1.19.1 as runtime dependency (to fix gitlab
    ssh access breakage). See #942633 for details.

 -- Pirate Praveen <praveen@debian.org>  Wed, 20 Nov 2019 15:42:46 +0530

gitaly (1.59.3+dfsg-1) experimental; urgency=medium

  [ Utkarsh Gupta ]
  * New upstream version 1.59.3+dfsg

  [ Pirate Praveen ]
  * Drop dh_auto_configure and move _support/generate-proto-ruby to
    override_dh_auto_build

 -- Pirate Praveen <praveen@debian.org>  Thu, 24 Oct 2019 22:46:00 +0530

gitaly (1.58.0+dfsg-2) experimental; urgency=medium

  * Binary included upload to work around buildd failure. 

 -- Pirate Praveen <praveen@debian.org>  Tue, 22 Oct 2019 18:45:54 +0530

gitaly (1.58.0+dfsg-1) experimental; urgency=medium

  * New upstream version 1.58.0+dfsg
  * Bump Standards-Version to 4.4.1 (no changes needed)
  * Generate new binary ruby-gitaly
  * Remove generated files

 -- Sruthi Chandran <srud@debian.org>  Sun, 20 Oct 2019 22:54:28 +0530

gitaly (1.53.3+debian-1) experimental; urgency=medium

  * New upstream version 1.53.3+debian

 -- Sruthi Chandran <srud@debian.org>  Mon, 30 Sep 2019 18:29:01 +0530

gitaly (1.47.3+debian-1) experimental; urgency=medium

  * New upstream version 1.47.3+debian
  * Refresh patches
  * Reintroduce vendor/ to embed dependencies

 -- Sruthi Chandran <srud@debian.org>  Fri, 27 Sep 2019 17:13:01 +0530

gitaly (1.42.5+debian-1) experimental; urgency=medium

  * New upstream version 1.42.5+debian
  * Bump Standards-Version to 4.4.0 (no changes needed)

 -- Pirate Praveen <praveen@debian.org>  Sun, 11 Aug 2019 15:19:04 +0530

=== debian/control ===
Source: gitaly
Section: net
Priority: optional
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Pirate Praveen <praveen@debian.org>,
 Sruthi Chandran <srud@debian.org>
Build-Depends: debhelper (>= 11~),
 dh-golang (>= 1.43~),
 golang-any (>= 2:1.13~),
 golang-github-beorn7-perks-dev,
 golang-github-burntsushi-toml-dev,
 golang-github-davecgh-go-spew-dev,
 golang-goprotobuf-dev (>= 1.3~),
#~ golang-github-grpc-ecosystem-go-grpc-prometheus-dev,
 golang-github-google-uuid-dev,
 golang-protobuf-extensions-dev,
#~ golang-github-getsentry-raven-go-dev,
 golang-gopkg-libgit2-git2go.v28-dev,
 golang-github-pmezard-go-difflib-dev,
 golang-github-prometheus-client-golang-dev,
 golang-github-prometheus-client-model-dev,
 golang-github-prometheus-common-dev,
 golang-github-stretchr-testify-dev,
 golang-github-sirupsen-logrus-dev (>= 1.0~),
 golang-golang-x-crypto-dev,
 golang-golang-x-net-dev,
 golang-golang-x-sync-dev,
 golang-golang-x-sys-dev,
 golang-golang-x-text-dev,
 golang-golang-x-tools,
 golang-google-grpc-dev (>= 1.22~),
#~ golang-google-genproto-dev,
 golang-github-kelseyhightower-envconfig-dev,
 golang-procfs-dev,
 golang-github-lib-pq-dev,
 protobuf-compiler,
# Tests:
#  ,git
#  ,procps
 gem2deb,
 ruby-bundler,
 ruby-rugged (>= 0.28.1~),
 ruby-github-linguist (>= 7.5~),
 ruby-github-markup (>= 1.7.0~),
 ruby-activesupport (>= 2:5.2.3~),
 ruby-gollum-lib (>= 4.2.7.7~),
 ruby-gollum-rugged-adapter (>= 0.4.4.2~),
 ruby-grpc,
 ruby-grpc-tools,
 ruby-sentry-raven (>= 2.9~),
 ruby-faraday (>= 0.12~),
 ruby-rbtrace,
 ruby-gitlab-labkit (>= 0.5~),
 ruby-licensee (>= 8.9~),
 ruby-google-protobuf
Standards-Version: 4.4.1
Homepage: https://gitlab.com/gitlab-org/gitaly
Vcs-Git: https://salsa.debian.org/go-team/packages/gitaly.git
Vcs-Browser: https://salsa.debian.org/go-team/packages/gitaly
XS-Ruby-Versions: all
XS-Go-Import-Path: gitlab.com/gitlab-org/gitaly

Package: gitaly
Architecture: any
Built-Using: ${misc:Built-Using}
Depends: ${shlibs:Depends}, ${misc:Depends},
     gitlab-common,
     ruby | ruby-interpreter,
     ruby-rugged (>= 0.28.1~),
     ruby-github-linguist (>= 7.5~),
     ruby-github-markup (>= 1.7.0~),
     ruby-activesupport (>= 2:5.2.3~),
     ruby-gollum-lib (>= 4.2.7.7~),
     ruby-gollum-rugged-adapter (>= 0.4.4.2~),
     ruby-grpc,
     ruby-sentry-raven (>= 2.9.0~),
     ruby-faraday (>= 0.12~),
     ruby-rbtrace,
     ruby-gitlab-labkit (>= 0.5~),
     ruby-licensee (>= 8.9~),
     ruby-google-protobuf,
# sysv deps:
     pipexec,
     procps
Description: Git RPC service for handling all the git calls made by GitLab
 Gitaly makes the git data storage tier of large GitLab instances fast.
 .
 This is achieved by moving git operations as close to the data as possible and
 Optimizing git services using caching.
 .
 Gitaly is a core service of gitlab.

Package: ruby-gitaly
Section: ruby
Architecture: all
XB-Ruby-Versions: ${ruby:Versions}
Depends: ruby | ruby-interpreter,
         ruby-google-protobuf (>= 3.1~),
         ruby-grpc (>= 1.10~),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Auto-generated gRPC client for gitaly
 Auto-generated gRPC ruby client for gitaly.
 .
 Gitaly is part of GitLab. It is a server application that uses its own gRPC
 protocol to communicate with its clients.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DH_GOLANG_GO_GENERATE := 1
#export DH_GOLANG_INSTALL_ALL := 1  # test data
#export DH_GOLANG_INSTALL_EXTRA := vendor
export DH_RUBY = --gem-install
export DH_RUBY_USE_DH_AUTO_INSTALL_DESTDIR = debian/ruby-gitaly
export GEM2DEB_TEST_RUNNER = --check-dependencies

include /usr/share/dpkg/pkg-info.mk
## Set some build variables as per Makefile:
VERSION  ?= $(shell sh -c 'printf "$${1%%+dfsg*}"' -- "$(DEB_VERSION_UPSTREAM)")
PKG := gitlab.com/gitlab-org/gitaly
GO_LDFLAGS ?= -X $(PKG)/internal/version.version=$(VERSION)

%:
	dh $@  --buildsystem=golang --with=golang --package=gitaly
	dh $@  --buildsystem=ruby --with=ruby --package=ruby-gitaly

override_dh_clean:
	dh_clean
	rm -rf ruby/proto/gitaly/*_pb.rb
	dh_auto_clean -O--buildsystem=golang -O--package=gitaly
	dh_auto_clean -O--buildsystem=ruby -O--package=ruby-gitaly

override_dh_auto_build:
	dh_auto_build -O--buildsystem=golang -O--package=gitaly -- \
	   -ldflags "$(GO_LDFLAGS)"
	_support/generate-proto-ruby
	dh_auto_build -O--buildsystem=ruby -O--package=ruby-gitaly

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	-dh_auto_test -O--buildsystem=golang -O--package=gitaly
	dh_auto_test -O--buildsystem=ruby -O--package=ruby-gitaly
	# Test if ruby dependencies are satisfied
	TMPDIR=$$(mktemp -d); cp ruby/Gemfile $$TMPDIR; cd $$TMPDIR;\
        bundle install --local || exit 1;\
        rm $$TMPDIR/Gemfile*; rmdir $$TMPDIR
endif

override_dh_auto_install:
	dh_auto_install -O--buildsystem=golang -O--package=gitaly --destdir=debian/gitaly
	dh_auto_install -O--buildsystem=ruby -O--package=ruby-gitaly --destdir=debian/ruby-gitaly
	$(RM) -rv debian/gitaly/usr/share/gocode

override_dh_install:
	dh_install
	$(RM) -rv debian/gitaly/usr/share/gitaly/ruby/Gemfile.lock
	$(RM) -rv debian/gitaly/usr/share/gitaly/ruby/.gitignore
	$(RM) -rv debian/gitaly/usr/share/gitaly/ruby/gitlab-shell/.gitignore

## gitaly 13.2.1+dfsg

=== Makefile ===
# Makefile for Gitaly

# You can override options by creating a "config.mak" file in Gitaly's root
# directory.
-include config.mak

# Call `make V=1` in order to print commands verbosely.
ifeq ($(V),1)
    Q =
else
    Q = @
endif

SHELL = /usr/bin/env bash -eo pipefail

# Host information
OS   := $(shell uname)
ARCH := $(shell uname -m)

# Directories
SOURCE_DIR       := $(abspath $(dir $(lastword ${MAKEFILE_LIST})))
BUILD_DIR        := ${SOURCE_DIR}/_build
COVERAGE_DIR     := ${BUILD_DIR}/cover
GITALY_RUBY_DIR  := ${SOURCE_DIR}/ruby
GITLAB_SHELL_DIR := ${GITALY_RUBY_DIR}/gitlab-shell

# These variables may be overridden at runtime by top-level make
PREFIX           ?= /usr/local
prefix           ?= ${PREFIX}
exec_prefix      ?= ${prefix}
bindir           ?= ${exec_prefix}/bin
INSTALL_DEST_DIR := ${DESTDIR}${bindir}
ASSEMBLY_ROOT    ?= ${BUILD_DIR}/assembly
GIT_PREFIX       ?= ${GIT_INSTALL_DIR}

# Tools
GOIMPORTS         := ${BUILD_DIR}/bin/goimports
GITALYFMT         := ${BUILD_DIR}/bin/gitalyfmt
GOLANGCI_LINT     := ${BUILD_DIR}/bin/golangci-lint
GO_LICENSES       := ${BUILD_DIR}/bin/go-licenses
PROTOC            := ${BUILD_DIR}/protoc/bin/protoc
PROTOC_GEN_GO     := ${BUILD_DIR}/bin/protoc-gen-go
PROTOC_GEN_GITALY := ${BUILD_DIR}/bin/protoc-gen-gitaly
GO_JUNIT_REPORT   := ${BUILD_DIR}/bin/go-junit-report

# Build information
BUNDLE_FLAGS    ?= $(shell test -f ${SOURCE_DIR}/../.gdk-install-root && echo --no-deployment || echo --deployment)
GITALY_PACKAGE  := gitlab.com/gitlab-org/gitaly
BUILD_TIME      := $(shell date +"%Y%m%d.%H%M%S")
GITALY_VERSION  := $(shell git describe --match v* 2>/dev/null | sed 's/^v//' || cat ${SOURCE_DIR}/VERSION 2>/dev/null || echo unknown)
GO_LDFLAGS      := -ldflags '-X ${GITALY_PACKAGE}/internal/version.version=${GITALY_VERSION} -X ${GITALY_PACKAGE}/internal/version.buildtime=${BUILD_TIME}'
GO_TEST_LDFLAGS := -X gitlab.com/gitlab-org/gitaly/auth.timestampThreshold=5s
GO_BUILD_TAGS   := tracer_static tracer_static_jaeger continuous_profiler_stackdriver

# Dependency versions
GOLANGCI_LINT_VERSION ?= 1.27.0
PROTOC_VERSION        ?= 3.6.1
PROTOC_GEN_GO_VERSION ?= 1.3.2
GIT_VERSION           ?= v2.27.0

# Dependency downloads
ifeq (${OS},Darwin)
    PROTOC_URL            ?= https://github.com/protocolbuffers/protobuf/releases/download/v${PROTOC_VERSION}/protoc-${PROTOC_VERSION}-osx-x86_64.zip
    PROTOC_HASH           ?= 0decc6ce5beed07f8c20361ddeb5ac7666f09cf34572cca530e16814093f9c0c
    GOLANGCI_LINT_ARCHIVE ?= golangci-lint-${GOLANGCI_LINT_VERSION}-darwin-amd64
    GOLANGCI_LINT_HASH    ?= 3fb1a1683a29c6c0a8cd76135f62b606fbdd538d5a7aeab94af1af70ffdc2fd4
else ifeq (${OS},Linux)
    PROTOC_URL            ?= https://github.com/protocolbuffers/protobuf/releases/download/v${PROTOC_VERSION}/protoc-${PROTOC_VERSION}-linux-x86_64.zip
    PROTOC_HASH           ?= 6003de742ea3fcf703cfec1cd4a3380fd143081a2eb0e559065563496af27807
    GOLANGCI_LINT_ARCHIVE ?= golangci-lint-${GOLANGCI_LINT_VERSION}-linux-amd64
    GOLANGCI_LINT_HASH    ?= 8d345e4e88520e21c113d81978e89ad77fc5b13bfdf20e5bca86b83fc4261272
else
    $(error Unsupported OS: ${OS})
endif
GOLANGCI_LINT_URL ?= https://github.com/golangci/golangci-lint/releases/download/v${GOLANGCI_LINT_VERSION}/${GOLANGCI_LINT_ARCHIVE}.tar.gz

# Git target
GIT_REPO_URL      ?= https://gitlab.com/gitlab-org/gitlab-git.git
GIT_BINARIES_URL  ?= https://gitlab.com/gitlab-org/gitlab-git/-/jobs/artifacts/${GIT_VERSION}/raw/git_full_bins.tgz?job=build
GIT_BINARIES_HASH ?= 7947f05069a61351992ae5857db077223e740ca5928b1686dac43032637163e5
GIT_INSTALL_DIR   := ${BUILD_DIR}/git
GIT_SOURCE_DIR    := ${BUILD_DIR}/src/git

ifeq (${GIT_BUILD_OPTIONS},)
    # activate developer checks
    GIT_BUILD_OPTIONS += DEVELOPER=1
    # make it easy to debug in case of crashes
    GIT_BUILD_OPTIONS += CFLAGS='-O0 -g3'
    GIT_BUILD_OPTIONS += NO_PERL=YesPlease
    GIT_BUILD_OPTIONS += NO_EXPAT=YesPlease
    GIT_BUILD_OPTIONS += NO_TCLTK=YesPlease
    # fix compilation on musl libc
    GIT_BUILD_OPTIONS += NO_REGEX=YesPlease
    GIT_BUILD_OPTIONS += NO_GETTEXT=YesPlease
    GIT_BUILD_OPTIONS += NO_PYTHON=YesPlease
    GIT_BUILD_OPTIONS += NO_INSTALL_HARDLINKS=YesPlease
    GIT_BUILD_OPTIONS += NO_R_TO_GCC_LINKER=YesPlease
endif

# These variables control test options and artifacts
TEST_OPTIONS    ?=
TEST_REPORT_DIR ?= ${BUILD_DIR}/reports
TEST_OUTPUT     ?= ${TEST_REPORT_DIR}/go-tests-output-${CI_JOB_NAME}.txt
TEST_REPORT     ?= ${TEST_REPORT_DIR}/go-tests-report-${CI_JOB_NAME}.xml
TEST_EXIT       ?= ${TEST_REPORT_DIR}/go-tests-exit-${CI_JOB_NAME}.txt
TEST_REPO_DIR   := ${SOURCE_DIR}/internal/testhelper/testdata/data
TEST_REPO       := ${TEST_REPO_DIR}/gitlab-test.git
TEST_REPO_GIT   := ${TEST_REPO_DIR}/gitlab-git-test.git

# Find all commands.
find_commands         = $(notdir $(shell find ${SOURCE_DIR}/cmd -mindepth 1 -maxdepth 1 -type d -print))
# Find all command binaries.
find_command_binaries = $(addprefix ${BUILD_DIR}/bin/, $(call find_commands))

# Find all Go source files.
find_go_sources  = $(shell find ${SOURCE_DIR} -type d \( -name ruby -o -name vendor -o -name testdata -o -name '_*' -o -path '*/proto/go' \) -prune -o -type f -name '*.go' -not -name '*.pb.go' -print | sort -u)
# Find all Go packages.
find_go_packages = $(dir $(call find_go_sources, 's|[^/]*\.go||'))

unexport GOROOT
export GOBIN        = ${BUILD_DIR}/bin
export GO111MODULE  = on
export GOPROXY     ?= https://proxy.golang.org
export PATH        := ${BUILD_DIR}/bin:${PATH}

.NOTPARALLEL:

.PHONY: all
all: INSTALL_DEST_DIR = ${SOURCE_DIR}
all: install

.PHONY: build
build: ${SOURCE_DIR}/.ruby-bundle
	go install ${GO_LDFLAGS} -tags "${GO_BUILD_TAGS}" $(addprefix ${GITALY_PACKAGE}/cmd/, $(call find_commands))

.PHONY: install
install: build
	${Q}mkdir -p ${INSTALL_DEST_DIR}
	install $(call find_command_binaries) ${INSTALL_DEST_DIR}

.PHONY: force-ruby-bundle
force-ruby-bundle:
	${Q}rm -f ${SOURCE_DIR}/.ruby-bundle

# Assembles all runtime components into a directory
# Used by the GDK: run 'make assemble ASSEMBLY_ROOT=.../gitaly'
.PHONY: assemble
assemble: force-ruby-bundle assemble-internal

# assemble-internal does not force 'bundle install' to run again
.PHONY: assemble-internal
assemble-internal: assemble-ruby assemble-go

.PHONY: assemble-go
assemble-go: build
	${Q}rm -rf ${ASSEMBLY_ROOT}/bin
	${Q}mkdir -p ${ASSEMBLY_ROOT}/bin
	install $(call find_command_binaries) ${ASSEMBLY_ROOT}/bin

.PHONY: assemble-ruby
assemble-ruby:
	${Q}mkdir -p ${ASSEMBLY_ROOT}
	${Q}rm -rf ${GITALY_RUBY_DIR}/tmp ${GITLAB_SHELL_DIR}/tmp
	${Q}mkdir -p ${ASSEMBLY_ROOT}/ruby/
	rsync -a --delete  ${GITALY_RUBY_DIR}/ ${ASSEMBLY_ROOT}/ruby/
	${Q}rm -rf ${ASSEMBLY_ROOT}/ruby/spec ${ASSEMBLY_ROOT}/ruby/gitlab-shell/spec ${ASSEMBLY_ROOT}/ruby/gitlab-shell/gitlab-shell.log

.PHONY: binaries
binaries: assemble
	${Q}if [ ${ARCH} != 'x86_64' ]; then echo Incorrect architecture for build: ${ARCH}; exit 1; fi
	${Q}cd ${ASSEMBLY_ROOT} && shasum -a 256 bin/* | tee checksums.sha256.txt

.PHONY: prepare-tests
prepare-tests: ${GITLAB_SHELL_DIR}/config.yml ${TEST_REPO} ${TEST_REPO_GIT} ${SOURCE_DIR}/.ruby-bundle

.PHONY: test
test: test-go rspec rspec-gitlab-shell

.PHONY: test-go
test-go: prepare-tests ${GO_JUNIT_REPORT}
	${Q}mkdir -p ${TEST_REPORT_DIR}
	${Q}echo 0>${TEST_EXIT}
	${Q}go test ${TEST_OPTIONS} -v -tags "${GO_BUILD_TAGS}" -ldflags='${GO_TEST_LDFLAGS}' -count=1 $(call find_go_packages) 2>&1 | tee ${TEST_OUTPUT} || echo $$? >${TEST_EXIT}
	${Q}${GO_JUNIT_REPORT} <${TEST_OUTPUT} >${TEST_REPORT}
	${Q}exit `cat ${TEST_EXIT}`

.PHONY: test-with-proxies
test-with-proxies: prepare-tests
	${Q}go test -tags "${GO_BUILD_TAGS}" -count=1  -exec ${SOURCE_DIR}/_support/bad-proxies ${GITALY_PACKAGE}/internal/rubyserver/

.PHONY: test-with-praefect
test-with-praefect: build prepare-tests
	${Q}GITALY_TEST_PRAEFECT_BIN=${BUILD_DIR}/bin/praefect go test -tags "${GO_BUILD_TAGS}" -ldflags='${GO_TEST_LDFLAGS}' -count=1 $(call find_go_packages) # count=1 bypasses go 1.10 test caching

.PHONY: race-go
race-go: TEST_OPTIONS = -race
race-go: test-go

.PHONY: rspec
rspec: assemble-go prepare-tests
	${Q}cd ${GITALY_RUBY_DIR} && bundle exec rspec

.PHONY: rspec-gitlab-shell
rspec-gitlab-shell: ${GITLAB_SHELL_DIR}/config.yml assemble-go prepare-tests
	${Q}cd ${GITALY_RUBY_DIR} && bundle exec bin/ruby-cd ${GITLAB_SHELL_DIR} rspec

.PHONY: test-postgres
test-postgres: prepare-tests
	${Q}go test -tags postgres -count=1 gitlab.com/gitlab-org/gitaly/internal/praefect/...

.PHONY: verify
verify: check-mod-tidy check-formatting notice-up-to-date check-proto rubocop

.PHONY: check-mod-tidy
check-mod-tidy:
	${Q}${SOURCE_DIR}/_support/check-mod-tidy

.PHONY: lint
lint: ${GOLANGCI_LINT}
	${Q}${GOLANGCI_LINT} cache clean && ${GOLANGCI_LINT} run --out-format tab --config ${SOURCE_DIR}/.golangci.yml

.PHONY: check-formatting
check-formatting: ${GITALYFMT}
	${Q}${GITALYFMT} $(call find_go_sources) | awk '{ print } END { if(NR>0) { print "Formatting error, run make format"; exit(1) } }'

.PHONY: format
format: ${GOIMPORTS} ${GITALYFMT}
	${Q}${GOIMPORTS} -w -l $(call find_go_sources)
	${Q}${GITALYFMT} -w $(call find_go_sources)
	${Q}${GOIMPORTS} -w -l $(call find_go_sources)

.PHONY: staticcheck-deprecations
staticcheck-deprecations: ${GOLANGCI_LINT}
	${Q}${GOLANGCI_LINT} run --out-format tab --config ${SOURCE_DIR}/_support/golangci.warnings.yml

.PHONY: lint-warnings
lint-warnings: staticcheck-deprecations

.PHONY: notice-up-to-date
notice-up-to-date: ${BUILD_DIR}/NOTICE
	${Q}(cmp ${BUILD_DIR}/NOTICE ${SOURCE_DIR}/NOTICE) || (echo >&2 "NOTICE requires update: 'make notice'" && false)

.PHONY: notice
notice: ${SOURCE_DIR}/NOTICE

.PHONY: clean
clean:
	rm -rf ${BUILD_DIR} ${SOURCE_DIR}/internal/testhelper/testdata/data/ ${SOURCE_DIR}/ruby/.bundle/ ${SOURCE_DIR}/ruby/gitlab-shell/config.yml ${SOURCE_DIR}/ruby/vendor/bundle/ $(addprefix ${SOURCE_DIR}/, $(notdir $(call find_commands)))

.PHONY: clean-ruby-vendor-go
clean-ruby-vendor-go:
	mkdir -p ${SOURCE_DIR}/ruby/vendor && find ${SOURCE_DIR}/ruby/vendor -type f -name '*.go' -delete

.PHONY: check-proto
check-proto: proto no-changes

.PHONY: rubocop
rubocop: ${SOURCE_DIR}/.ruby-bundle
	${Q}cd ${GITALY_RUBY_DIR} && bundle exec rubocop --parallel

.PHONY: cover
cover: prepare-tests
	${Q}echo "NOTE: make cover does not exit 1 on failure, don't use it to check for tests success!"
	${Q}mkdir -p "${COVERAGE_DIR}"
	${Q}rm -f "${COVERAGE_DIR}/all.merged" "${COVERAGE_DIR}/all.html"
	${Q}go test -ldflags='${GO_TEST_LDFLAGS}' -coverprofile "${COVERAGE_DIR}/all.merged" $(call find_go_packages)
	${Q}go tool cover -html  "${COVERAGE_DIR}/all.merged" -o "${COVERAGE_DIR}/all.html"
	${Q}echo ""
	${Q}echo "=====> Total test coverage: <====="
	${Q}echo ""
	${Q}go tool cover -func "${COVERAGE_DIR}/all.merged"

.PHONY: docker
docker:
	${Q}rm -rf ${BUILD_DIR}/docker/
	${Q}mkdir -p ${BUILD_DIR}/docker/bin/
	${Q}rm -rf  ${GITALY_RUBY_DIR}/tmp
	cp -r  ${GITALY_RUBY_DIR} ${BUILD_DIR}/docker/ruby
	${Q}rm -rf ${BUILD_DIR}/docker/ruby/vendor/bundle
	for command in $(call find_commands); do \
		GOOS=linux GOARCH=amd64 go build -tags "${GO_BUILD_TAGS}" ${GO_LDFLAGS} -o "${BUILD_DIR}/docker/bin/$${command}" ${GITALY_PACKAGE}/cmd/$${command}; \
	done
	cp ${SOURCE_DIR}/Dockerfile ${BUILD_DIR}/docker/
	docker build -t gitlab/gitaly:v${GITALY_VERSION} -t gitlab/gitaly:latest ${BUILD_DIR}/docker/

.PHONY: proto
proto: ${PROTOC_GEN_GITALY} ${SOURCE_DIR}/.ruby-bundle
	${PROTOC} --gitaly_out=proto_dir=./proto,gitalypb_dir=./proto/go/gitalypb:. --go_out=paths=source_relative,plugins=grpc:./proto/go/gitalypb -I./proto ./proto/*.proto
	${SOURCE_DIR}/_support/generate-proto-ruby
	${Q}# this part is related to the generation of sources from testing proto files
	${PROTOC} --plugin=${PROTOC_GEN_GO} --go_out=plugins=grpc:. internal/praefect/grpc-proxy/testdata/test.proto

.PHONY: proto-lint
proto-lint: ${PROTOC} ${PROTOC_GEN_GO}
	${Q}mkdir -p ${SOURCE_DIR}/proto/go/gitalypb
	${Q}rm -rf ${SOURCE_DIR}/proto/go/gitalypb/*.pb.go

=== debian/changelog ===
gitaly (13.2.1+dfsg-2) unstable; urgency=medium

  * Add ruby-bundler as dependency (fixes piuparts installation failure)
  * Add conflicts libruby2.5 (to make sure all native packages are updated)

 -- Pirate Praveen <praveen@debian.org>  Mon, 10 Aug 2020 15:37:49 +0530

gitaly (13.2.1+dfsg-1) unstable; urgency=medium

  * New upstream version 13.2.1+dfsg

 -- Pirate Praveen <praveen@debian.org>  Sun, 09 Aug 2020 22:27:40 +0530

gitaly (13.1.0+dfsg-1) experimental; urgency=medium

  * New upstream version 13.1.0+dfsg
  * Update minimum version of gitlab-shell to 13.3
  * Add gitlab section and configure url to gitlab-workhorse.socket

 -- Pirate Praveen <praveen@debian.org>  Mon, 22 Jun 2020 23:57:55 +0530

gitaly (13.0.6+dfsg-1) experimental; urgency=medium

  * Update minimum versions of build depends (for backports)
  * ruby/Gemfile.lock is excluded from source tar (no need to remove it again)
  * New upstream version 13.0.6+dfsg

 -- Pirate Praveen <praveen@debian.org>  Sat, 13 Jun 2020 15:23:11 +0530

gitaly (13.0.0+dfsg-1) experimental; urgency=medium

  * Drop github.com/cloudflare/tableflip (use packaged version)
  * Drop github.com/dchest/safefile from vendor (use packaged version)
  * Drop github.com/google/shlex (not used)
  * New upstream version 13.0.0+dfsg
  * Refresh patches
  * Add gitlab-shell as build dependency
  * Exclude ruby/Gemfile.lock from future versions
  * Tighten dependencies
  * Add grpc-tools conditionally in ruby/Gemfile (only needed during build)

 -- Pirate Praveen <praveen@debian.org>  Sat, 30 May 2020 21:09:01 +0530

gitaly (12.10.0+dfsg-1) experimental; urgency=medium

  * Drop modules from vendor: gopkg.in/yaml.v2 github.com/wadey/gocovmerge
    github.com/uber/jaeger-lib github.com/uber/jaeger-client-go
    github.com/tinylib/msgp github.com/Bowery/prompt
    github.com/certifi/gocertifi gopkg.in/gorp.v1
    gopkg.in/DataDog/dd-trace-go.v1 github.com/rubenv/sql-migrate
    golang.org/x/tools golang.org/x/lint google.golang.org/genproto
    github.com/client9/reopen
  * New upstream version 12.10.0+dfsg
  * Refresh patches
  * Drop github.com/prometheus/client_golang from vendor
  * Relax dependency on grpc gem to use packaged version
  * Update README.source
  * Tighten dependencies

 -- Pirate Praveen <praveen@debian.org>  Wed, 22 Apr 2020 23:33:13 +0530

gitaly (12.9.3+dfsg-1) experimental; urgency=medium

  * New upstream version 12.9.3+dfsg
  * Add missing copyright notices for vendor/*

 -- Pirate Praveen <praveen@debian.org>  Wed, 15 Apr 2020 17:31:03 +0530

gitaly (12.9.2+dfsg-2) experimental; urgency=medium

  * Tighten dependency on ruby-grpc (for backports)
  * Add gitlab-common binary (moved from src:gitlab)

 -- Pirate Praveen <praveen@debian.org>  Sun, 12 Apr 2020 18:49:56 +0530

gitaly (12.9.2+dfsg-1) experimental; urgency=medium

  * New upstream version 12.9.2+dfsg (Closes: #956302)
  * Bump Standards-Version to 4.5.0 (no changes needed)
  * Refresh patches
  * Update build dependencies
  * Update minimum version of ruby-gollum-lib to 4.2.7.8
  * Update gitlab-labkit to 0.11.0

 -- Pirate Praveen <praveen@debian.org>  Thu, 09 Apr 2020 20:04:32 +0530

gitaly (1.86.0+dfsg1-1) experimental; urgency=medium

  [ Abhijith PA ]
  * New upstream release.
  * Refresh patches
  * Update copyright for;
    + vendor/github.com/rubenv/sql-migrate
    + vendor/gopkg.in/gorp.v1

  [ Pirate Praveen ]
  * Update dependency on activesupport and gitlab-labkit

 -- Pirate Praveen <praveen@debian.org>  Fri, 13 Mar 2020 18:36:33 +0530

=== debian/control ===
Source: gitaly
Section: net
Priority: optional
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Pirate Praveen <praveen@debian.org>,
 Sruthi Chandran <srud@debian.org>
Build-Depends: debhelper (>= 11~),
 dh-golang (>= 1.43~),
 golang-any (>= 2:1.13~),
 gitlab-shell (>= 13.2~),
 golang-github-beorn7-perks-dev,
 golang-github-burntsushi-toml-dev,
 golang-github-client9-reopen-dev,
 golang-github-cloudflare-tableflip-dev (>= 1.2~),
 golang-github-davecgh-go-spew-dev,
 golang-github-dchest-safefile-dev,
 golang-goprotobuf-dev (>= 1.3~),
#~ golang-github-grpc-ecosystem-go-grpc-prometheus-dev,
 golang-github-google-uuid-dev,
 golang-github-kelseyhightower-envconfig-dev,
 golang-protobuf-extensions-dev,
#~ golang-github-getsentry-raven-go-dev,
 golang-github-lib-pq-dev (>= 1.3~),
 golang-github-pmezard-go-difflib-dev,
 golang-github-prometheus-client-golang-dev,
 golang-github-prometheus-client-model-dev,
 golang-github-prometheus-common-dev,
 golang-github-rubenv-sql-migrate-dev,
 golang-github-sebest-xff-dev,
 golang-github-sirupsen-logrus-dev (>= 1.0~),
 golang-github-stretchr-testify-dev (>= 1.4~),
 golang-golang-x-crypto-dev,
 golang-golang-x-net-dev,
 golang-golang-x-sync-dev,
 golang-golang-x-sys-dev,
 golang-golang-x-text-dev,
 golang-golang-x-tools,
 golang-google-grpc-dev (>= 1.22~),
#~ golang-google-genproto-dev,
 golang-procfs-dev,
 golang-gopkg-gorp.v1-dev,
 golang-gopkg-libgit2-git2go.v28-dev,
 golang-gopkg-yaml.v2-dev,
 protobuf-compiler,
# Tests:
#  ,git
#  ,procps
 gem2deb,
 ruby-bundler,
 ruby-rugged (>= 0.28.1~),
 ruby-github-linguist (>= 7.9~),
 ruby-github-markup (>= 1.7.0~),
 ruby-activesupport (>= 2:6.0.3~),
 ruby-gollum-lib (>= 4.2.7.9~),
 ruby-gollum-rugged-adapter (>= 0.4.4.2~),
 ruby-grpc (>= 1.24~),
 ruby-grpc-tools (>= 1.24~),
 ruby-sentry-raven (>= 2.9~),
 ruby-faraday (>= 0.12~),
 ruby-rbtrace,
 ruby-gitlab-labkit (>= 0.12~),
 ruby-licensee (>= 8.9~),
 ruby-google-protobuf (>= 3.11.2~)
Standards-Version: 4.5.0
Homepage: https://gitlab.com/gitlab-org/gitaly
Vcs-Git: https://salsa.debian.org/go-team/packages/gitaly.git
Vcs-Browser: https://salsa.debian.org/go-team/packages/gitaly
XS-Ruby-Versions: all
XS-Go-Import-Path: gitlab.com/gitlab-org/gitaly

Package: gitaly
Architecture: any
Built-Using: ${misc:Built-Using}
Depends: ${shlibs:Depends}, ${misc:Depends},
     gitlab-common (=${source:Version}),
     ruby | ruby-interpreter,
     ruby-bundler,
     ruby-rugged (>= 0.28.1~),
     ruby-github-linguist (>= 7.9~),
     ruby-github-markup (>= 1.7.0~),
     ruby-activesupport (>= 2:6.0.3~),
     ruby-gollum-lib (>= 4.2.7.9~),
     ruby-gollum-rugged-adapter (>= 0.4.4.2~),
     ruby-grpc (>= 1.24~),
     ruby-sentry-raven (>= 2.9.0~),
     ruby-faraday (>= 0.12~),
     ruby-rbtrace,
     ruby-gitlab-labkit (>= 0.12~),
     ruby-licensee (>= 8.9~),
     ruby-google-protobuf (>= 3.11.2~),
# sysv deps:
     pipexec,
     procps
Conflicts: libruby2.5
Description: Git RPC service for handling all the git calls made by GitLab
 Gitaly makes the git data storage tier of large GitLab instances fast.
 .
 This is achieved by moving git operations as close to the data as possible and
 Optimizing git services using caching.
 .
 Gitaly is a core service of gitlab.

Package: ruby-gitaly
Section: ruby
Architecture: all
XB-Ruby-Versions: ${ruby:Versions}
Depends: ruby | ruby-interpreter,
         ruby-google-protobuf (>= 3.1~),
         ruby-grpc (>= 1.24~),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Auto-generated gRPC client for gitaly
 Auto-generated gRPC ruby client for gitaly.
 .
 Gitaly is part of GitLab. It is a server application that uses its own gRPC
 protocol to communicate with its clients.

Package: gitlab-common
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends},
 ruby | ruby-interpreter,
 adduser (>= 3.34~),
 git (>= 1:2.24~),
 ucf,
 gitlab-shell (>= 13.3~)
Description: git powered software platform to collaborate on code (common)
 gitlab provides web based interface to host source code and track issues.
 It allows anyone for fork a repository and send merge requests. Code review
 is possible using merge request workflow. Using groups and roles project
 access can be controlled.
 .
 This package includes configurations common to gitlab and gitaly.

=== debian/watch ===
version=3
opts=\
repacksuffix=+dfsg,\
repack,compression=xz,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/,\
filenamemangle=s/.*v(.*)\/.*/gitaly-$1.tar.gz/,\
dversionmangle=s/(\d)[\+]?(debian|dfsg|ds|deb|gh)\d*$/$1/ \
https://gitlab.com/gitlab-org/gitaly/tags?sort=updated_desc .*/gitaly-v(.*).tar.gz

## gitaly 13.3.0+dfsg

=== debian/changelog ===
gitaly (13.3.0+dfsg-1) unstable; urgency=medium

  * Team Upload
  * New upstream version 13.3.0+dfsg
  * Updated Patches
  * Add Upstream Metadata
  * Delete ruby/Gemfile.lock while cleaning

 -- Abraham Raji <avronr@tuta.io>  Thu, 24 Sep 2020 15:47:16 +0000

gitaly (13.2.1+dfsg-3) unstable; urgency=medium

  * Update minimum version of gitlab-shell (for using unix socket for
    gitlab_url in preparation of switching to puma)

 -- Pirate Praveen <praveen@debian.org>  Thu, 20 Aug 2020 23:01:38 +0530

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Build-Depends: debhelper (>= 11~),
  dh-golang (>= 1.43~),
  golang-any (>= 2:1.13~),
- gitlab-shell (>= 13.2~),
+ gitlab-shell (>= 13.6~),
  golang-github-beorn7-perks-dev,
  golang-github-burntsushi-toml-dev,
  golang-github-client9-reopen-dev,
@@ -122,7 +122,7 @@
  adduser (>= 3.34~),
  git (>= 1:2.24~),
  ucf,
- gitlab-shell (>= 13.3~)
+ gitlab-shell (>= 13.6~)
 Description: git powered software platform to collaborate on code (common)
  gitlab provides web based interface to host source code and track issues.
  It allows anyone for fork a repository and send merge requests. Code review

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,7 @@
 export DH_RUBY = --gem-install
 export DH_RUBY_USE_DH_AUTO_INSTALL_DESTDIR = debian/ruby-gitaly
 export GEM2DEB_TEST_RUNNER = --check-dependencies
+export RAILS_ENV = development # for bundle install --local test
 
 include /usr/share/dpkg/pkg-info.mk
 ## Set some build variables as per Makefile:
@@ -17,9 +18,9 @@
 %:
 	dh $@  --buildsystem=golang --with=golang --package=gitaly
 	dh $@  --buildsystem=ruby --with=ruby --package=ruby-gitaly
+	dh $@  --package=gitlab-common
 
-override_dh_clean:
-	dh_clean
+override_dh_auto_clean:
 	rm -rf ruby/proto/gitaly/*_pb.rb
 	dh_auto_clean -O--buildsystem=golang -O--package=gitaly
 	dh_auto_clean -O--buildsystem=ruby -O--package=ruby-gitaly
@@ -27,7 +28,7 @@
 override_dh_auto_build:
 	dh_auto_build -O--buildsystem=golang -O--package=gitaly -- \
 	   -ldflags "$(GO_LDFLAGS)"
-	_support/generate-proto-ruby
+	RAILS_ENV=$(RAILS_ENV) _support/generate-proto-ruby
 	dh_auto_build -O--buildsystem=ruby -O--package=ruby-gitaly
 
 override_dh_auto_test:
@@ -36,8 +37,9 @@
 	dh_auto_test -O--buildsystem=ruby -O--package=ruby-gitaly
 	# Test if ruby dependencies are satisfied
 	TMPDIR=$$(mktemp -d); cp ruby/Gemfile $$TMPDIR; cd $$TMPDIR;\
-        bundle install --local || exit 1;\
-        rm $$TMPDIR/Gemfile*; rmdir $$TMPDIR
+        RAILS_ENV=$(RAILS_ENV) bundle install --local || exit 1;\
+        rm $$TMPDIR/Gemfile* $$TMPDIR/.bundle/config;\
+       	rmdir $$TMPDIR/config; rmdir $$TMPDIR
 endif
 
 override_dh_auto_install:

## gitaly 13.3.9+dfsg

=== Makefile ===
--- 
+++ 
@@ -50,29 +50,22 @@
 GITALY_VERSION  := $(shell git describe --match v* 2>/dev/null | sed 's/^v//' || cat ${SOURCE_DIR}/VERSION 2>/dev/null || echo unknown)
 GO_LDFLAGS      := -ldflags '-X ${GITALY_PACKAGE}/internal/version.version=${GITALY_VERSION} -X ${GITALY_PACKAGE}/internal/version.buildtime=${BUILD_TIME}'
 GO_TEST_LDFLAGS := -X gitlab.com/gitlab-org/gitaly/auth.timestampThreshold=5s
-GO_BUILD_TAGS   := tracer_static tracer_static_jaeger continuous_profiler_stackdriver
+GO_BUILD_TAGS   := tracer_static,tracer_static_jaeger,continuous_profiler_stackdriver
 
 # Dependency versions
 GOLANGCI_LINT_VERSION ?= 1.27.0
-PROTOC_VERSION        ?= 3.6.1
+PROTOC_VERSION        ?= 3.12.4
 PROTOC_GEN_GO_VERSION ?= 1.3.2
 GIT_VERSION           ?= v2.27.0
 
 # Dependency downloads
 ifeq (${OS},Darwin)
     PROTOC_URL            ?= https://github.com/protocolbuffers/protobuf/releases/download/v${PROTOC_VERSION}/protoc-${PROTOC_VERSION}-osx-x86_64.zip
-    PROTOC_HASH           ?= 0decc6ce5beed07f8c20361ddeb5ac7666f09cf34572cca530e16814093f9c0c
-    GOLANGCI_LINT_ARCHIVE ?= golangci-lint-${GOLANGCI_LINT_VERSION}-darwin-amd64
-    GOLANGCI_LINT_HASH    ?= 3fb1a1683a29c6c0a8cd76135f62b606fbdd538d5a7aeab94af1af70ffdc2fd4
+    PROTOC_HASH           ?= 210227683a5db4a9348cd7545101d006c5829b9e823f3f067ac8539cb387519e
 else ifeq (${OS},Linux)
     PROTOC_URL            ?= https://github.com/protocolbuffers/protobuf/releases/download/v${PROTOC_VERSION}/protoc-${PROTOC_VERSION}-linux-x86_64.zip
-    PROTOC_HASH           ?= 6003de742ea3fcf703cfec1cd4a3380fd143081a2eb0e559065563496af27807
-    GOLANGCI_LINT_ARCHIVE ?= golangci-lint-${GOLANGCI_LINT_VERSION}-linux-amd64
-    GOLANGCI_LINT_HASH    ?= 8d345e4e88520e21c113d81978e89ad77fc5b13bfdf20e5bca86b83fc4261272
-else
-    $(error Unsupported OS: ${OS})
+    PROTOC_HASH           ?= d0d4c7a3c08d3ea9a20f94eaface12f5d46d7b023fe2057e834a4181c9e93ff3
 endif
-GOLANGCI_LINT_URL ?= https://github.com/golangci/golangci-lint/releases/download/v${GOLANGCI_LINT_VERSION}/${GOLANGCI_LINT_ARCHIVE}.tar.gz
 
 # Git target
 GIT_REPO_URL      ?= https://gitlab.com/gitlab-org/gitlab-git.git
@@ -119,7 +112,6 @@
 
 unexport GOROOT
 export GOBIN        = ${BUILD_DIR}/bin
-export GO111MODULE  = on
 export GOPROXY     ?= https://proxy.golang.org
 export PATH        := ${BUILD_DIR}/bin:${PATH}
 
@@ -206,7 +198,7 @@
 
 .PHONY: test-postgres
 test-postgres: prepare-tests
-	${Q}go test -tags postgres -count=1 gitlab.com/gitlab-org/gitaly/internal/praefect/...
+	${Q}go test -tags "${GO_BUILD_TAGS}",postgres -count=1 gitlab.com/gitlab-org/gitaly/internal/praefect/...
 
 .PHONY: verify
 verify: check-mod-tidy check-formatting notice-up-to-date check-proto rubocop
@@ -217,7 +209,7 @@
 
 .PHONY: lint
 lint: ${GOLANGCI_LINT}
-	${Q}${GOLANGCI_LINT} cache clean && ${GOLANGCI_LINT} run --out-format tab --config ${SOURCE_DIR}/.golangci.yml
+	${Q}${GOLANGCI_LINT} cache clean && ${GOLANGCI_LINT} run --build-tags "${GO_BUILD_TAGS}" --out-format tab --config ${SOURCE_DIR}/.golangci.yml
 
 .PHONY: check-formatting
 check-formatting: ${GITALYFMT}
@@ -231,7 +223,7 @@
 
 .PHONY: staticcheck-deprecations
 staticcheck-deprecations: ${GOLANGCI_LINT}
-	${Q}${GOLANGCI_LINT} run --out-format tab --config ${SOURCE_DIR}/_support/golangci.warnings.yml
+	${Q}${GOLANGCI_LINT} run --build-tags "${GO_BUILD_TAGS}" --out-format tab --config ${SOURCE_DIR}/_support/golangci.warnings.yml
 
 .PHONY: lint-warnings
 lint-warnings: staticcheck-deprecations
@@ -263,7 +255,7 @@
 	${Q}echo "NOTE: make cover does not exit 1 on failure, don't use it to check for tests success!"
 	${Q}mkdir -p "${COVERAGE_DIR}"
 	${Q}rm -f "${COVERAGE_DIR}/all.merged" "${COVERAGE_DIR}/all.html"
-	${Q}go test -ldflags='${GO_TEST_LDFLAGS}' -coverprofile "${COVERAGE_DIR}/all.merged" $(call find_go_packages)
+	${Q}go test -tags "${GO_BUILD_TAGS}" -ldflags='${GO_TEST_LDFLAGS}' -coverprofile "${COVERAGE_DIR}/all.merged" $(call find_go_packages)
 	${Q}go tool cover -html  "${COVERAGE_DIR}/all.merged" -o "${COVERAGE_DIR}/all.html"
 	${Q}echo ""
 	${Q}echo "=====> Total test coverage: <====="
@@ -294,3 +286,17 @@
 proto-lint: ${PROTOC} ${PROTOC_GEN_GO}
 	${Q}mkdir -p ${SOURCE_DIR}/proto/go/gitalypb
 	${Q}rm -rf ${SOURCE_DIR}/proto/go/gitalypb/*.pb.go
+	${PROTOC} --go_out=paths=source_relative:./proto/go/gitalypb -I./proto ./proto/lint.proto
+
+.PHONY: no-changes
+no-changes:
+	${Q}git status --porcelain | awk '{ print } END { if (NR > 0) { exit 1 } }'
+
+.PHONY: smoke-test
+smoke-test: all rspec
+	${Q}go test -tags "${GO_BUILD_TAGS}" ./internal/rubyserver
+
+.PHONY: download-git
+download-git: ${BUILD_DIR}/git_full_bins.tgz
+	${Q}rm -rf ${GIT_INSTALL_DIR}
+	${Q}mkdir -p ${GIT_INSTALL_DIR}

=== debian/changelog ===
gitaly (13.3.9+dfsg-1) unstable; urgency=medium

  * New upstream version 13.3.9+dfsg

 -- Pirate Praveen <praveen@debian.org>  Sat, 07 Nov 2020 15:33:39 +0530

gitaly (13.3.0+dfsg-2) unstable; urgency=medium

  * Source only upload for migration to testing (gem2deb now fixed to work with
    new version of bundler)

 -- Pirate Praveen <praveen@debian.org>  Tue, 03 Nov 2020 22:46:19 +0530
